Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1376)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1377)
@@ -2237,8 +1966,8 @@
     {
       TComPicYuv*  pcPicYuvRec  = *(iterPicYuvRec++);
-      if( !m_acLayerCfg[layer].getReconFile().empty() && pcPicYuvRec->isReconstructed() )
-      {
-        m_acTVideoIOYuvReconFile[layer].write( pcPicYuvRec, ipCSC, m_acLayerCfg[layer].getConfWinLeft() * xScal, m_acLayerCfg[layer].getConfWinRight() * xScal,
-          m_acLayerCfg[layer].getConfWinTop() * yScal, m_acLayerCfg[layer].getConfWinBottom() * yScal,
+      if( !m_apcLayerCfg[layer]->getReconFile().empty() && pcPicYuvRec->isReconstructed() )
+      {
+        m_apcTVideoIOYuvReconFile[layer]->write( pcPicYuvRec, ipCSC, m_apcLayerCfg[layer]->getConfWinLeft() * xScal, m_apcLayerCfg[layer]->getConfWinRight() * xScal,
+          m_apcLayerCfg[layer]->getConfWinTop() * yScal, m_apcLayerCfg[layer]->getConfWinBottom() * yScal,
           NUM_CHROMA_FORMAT, m_bClipOutputVideoToRec709Range  );
       }
@@ -2431,5 +2160,5 @@
 {
 #if SVC_EXTENSION
-  Double time = (Double) m_iFrameRcvd / m_acLayerCfg[m_numLayers-1].getFrameRate();
+  Double time = (Double) m_iFrameRcvd / m_apcLayerCfg[m_numLayers-1]->getFrameRate();
 #else
   Double time = (Double) m_iFrameRcvd / m_iFrameRate;
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.h
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.h	(revision 1376)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncTop.h	(revision 1377)
@@ -60,8 +60,7 @@
   // class interface
 #if SVC_EXTENSION
-  TEncTop                    m_acTEncTop [MAX_LAYERS];                    ///< encoder class
-  TEncTop*                   m_apcTEncTop [MAX_LAYERS];                   ///< encoder pointer class
-  TVideoIOYuv                m_acTVideoIOYuvInputFile [MAX_LAYERS];       ///< input YUV file
-  TVideoIOYuv                m_acTVideoIOYuvReconFile [MAX_LAYERS];       ///< output reconstruction file
+  TEncTop*                   m_apcTEncTop[MAX_LAYERS];                    ///< encoder pointer class
+  TVideoIOYuv*               m_apcTVideoIOYuvInputFile[MAX_LAYERS];       ///< input YUV file
+  TVideoIOYuv*               m_apcTVideoIOYuvReconFile[MAX_LAYERS];       ///< output reconstruction file
 
   TComList<TComPicYuv*>      m_acListPicYuvRec [MAX_LAYERS];              ///< list of reconstruction YUV files
@@ -114,5 +113,5 @@
   Void        encode      ();                               ///< main encoding function
 #if SVC_EXTENSION
-  TEncTop&    getTEncTop  (UInt layer)   { return  m_acTEncTop[layer]; }      ///< return encoder class pointer reference
+  TEncTop&    getTEncTop  (UInt layer)   { return  *m_apcTEncTop[layer]; }      ///< return encoder class pointer reference
 #else
   TEncTop&    getTEncTop  ()   { return  m_cTEncTop; }      ///< return encoder class pointer reference
Index: branches/SHM-dev/source/App/TAppEncoder/encmain.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/encmain.cpp	(revision 1376)
+++ branches/SHM-dev/source/App/TAppEncoder/encmain.cpp	(revision 1377)
@@ -72,4 +72,16 @@
   try
   {
+#if SVC_EXTENSION
+    // parse number of layers first to allocate memory in the buffers
+    if(!cTAppEncTop.parseCfgNumLayersAndInit( argc, argv ))
+    {
+      cTAppEncTop.destroy();
+#if ENVIRONMENT_VARIABLE_DEBUG_AND_TEST
+      EnvVar::printEnvVar();
+#endif
+      return 1;
+    }
+#endif
+
     if(!cTAppEncTop.parseCfg( argc, argv ))
     {
